// PA0 (A0) (ADC_IN0) - men pulzy
// PA6 (A5) (TIM3_CH1) - sputn AD pevod
// PB0 (D3) (TIM3_CH3) - informan vstup (sputn ADC)
// PB1 (D6) - informan vstup (reset ADC+DMA)

#include "main.h"
#include "string.h"

#define INFO_H LL_GPIO_SetOutputPin(GPIOB,LL_GPIO_PIN_1)
#define INFO_L LL_GPIO_ResetOutputPin(GPIOB,LL_GPIO_PIN_1)

void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_ADC_Init(void);
void init_TIM3(void);
void get_pulses(void);

#define PULSE_COUNT 16
#define SAMPLES 64
volatile uint16_t pulses[PULSE_COUNT][SAMPLES]; // tady sbrme celkem 16 pulz, kad po 64 vzorcch (zmnit na uint16_t pokud mte pevod 10 nebo 12bit)
volatile uint8_t hotovo; // informuje hlavn smyku o tom e sbr vech pulz skonil
volatile uint16_t pulse=0; // pot pulzy v rmci jeden sady (je pstupn zbytku programu)
uint32_t cnt=0; // pot poet sad pulz (jen tak)
uint32_t uzitecna_cinnost=0; // njak uiten innost v mezi ase


int main(void){
	// zkladn inicializace
  LL_APB1_GRP2_EnableClock(LL_APB1_GRP2_PERIPH_SYSCFG);
  LL_APB1_GRP1_EnableClock(LL_APB1_GRP1_PERIPH_PWR);
  SystemClock_Config(); // 48MHZ (z HSI48)
  MX_GPIO_Init(); // konfigurace informanho vstupu (PB1)
  MX_ADC_Init(); // konfigurace ADC, vstup i DMA
  init_TIM3(); // konfigurace TIM3 (trigrovacho systmu pro ADC) a pidruench GPIO

  // konfigurace ADC kanlu
 	LL_ADC_REG_SetSequencerChannels(ADC1, LL_ADC_CHANNEL_0); // vstupem je ADC_IN0 (pouze)
 	LL_ADC_SetSamplingTimeCommonChannels(ADC1, LL_ADC_SAMPLINGTIME_1CYCLE_5); // vzrokovac as je co nejkrat
		hotovo=1; // spust prvn men

  while (1){
  	if(hotovo){ // pokud jsme provedli PULSE_COUNT men, mme data ke zpracovn
  		INFO_H; // informujeme e probh "zpracovn"
  		pulse=0; // vynulujeme potadlo pulz
  		// pipravme dal sbr (stejn jako v DMA IRQ rutin)
  		LL_DMA_DisableChannel(DMA1,LL_DMA_CHANNEL_1);
  		LL_DMA_SetMemoryAddress(DMA1,LL_DMA_CHANNEL_1,(uint32_t)&pulses[pulse][0]);
  		LL_DMA_SetDataLength(DMA1,LL_DMA_CHANNEL_1,SAMPLES);
  		LL_DMA_EnableChannel(DMA1,LL_DMA_CHANNEL_1);
  		while(!LL_DMA_IsEnabledChannel(DMA1,LL_DMA_CHANNEL_1));
  		LL_ADC_REG_StartConversion(ADC1); // od te ADC ek na trigger a pak zahj sekvenci pevod
  		hotovo=0;
  		cnt++; // potme poet sad pulz... jen tak.
  		INFO_L;
  	}
  	uzitecna_cinnost++ ; // dlme nco smysluplnho
  }
}

// TIM3 snm vzestupnou hranu na trigger signlu a spout serii AD pevod - funguje jako extern trigger pro ADC
void init_TIM3(void){
LL_GPIO_InitTypeDef GPIO_InitStruct;

LL_AHB1_GRP1_EnableClock(LL_AHB1_GRP1_PERIPH_GPIOA);
LL_AHB1_GRP1_EnableClock(LL_AHB1_GRP1_PERIPH_GPIOB);
LL_APB1_GRP1_EnableClock(LL_APB1_GRP1_PERIPH_TIM3);

	// PA6 (TIM3_CH1) - budouc vstup pro trigger
 GPIO_InitStruct.Pin = LL_GPIO_PIN_6;
 GPIO_InitStruct.Mode = LL_GPIO_MODE_ALTERNATE;
 GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
 GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
 GPIO_InitStruct.Pull = LL_GPIO_PULL_DOWN;
 GPIO_InitStruct.Alternate = LL_GPIO_AF_1;
 LL_GPIO_Init(GPIOA, &GPIO_InitStruct);
// PB0 (TIM3_CH3) - informan vstup
 GPIO_InitStruct.Pin = LL_GPIO_PIN_0;
 GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
 LL_GPIO_Init(GPIOB, &GPIO_InitStruct);

 // konfigurace Timeru
 LL_TIM_SetPrescaler(TIM3,0); // frekvence 48MHz
 LL_TIM_SetAutoReload(TIM3,2); // strop minimln (chceme aby se timer vas vypnul a byl pipraven snmat dal pulz)
 LL_TIM_SetOnePulseMode(TIM3,LL_TIM_ONEPULSEMODE_SINGLE); // one-shot, timer se po peteen sm vypne (a bude ekat na dal trigger)

 // konfigurace IC kanlu (vstup pro trigger timeru)
 LL_TIM_IC_SetPolarity(TIM3,LL_TIM_CHANNEL_CH1,LL_TIM_IC_POLARITY_RISING); // detekovat vzestupnou hranu
 LL_TIM_IC_SetFilter(TIM3,LL_TIM_CHANNEL_CH1,LL_TIM_IC_FILTER_FDIV1); // digitln filtr vypntut
 // od te jde na TI1FP1 pulz okamit po detekci vzestupn hrany na CH1 (PA6)

 // Informan vstup timeru generuje pulz
 LL_TIM_OC_SetMode(TIM3,LL_TIM_CHANNEL_CH3,LL_TIM_OCMODE_PWM2); // md PWM (zarovnan na "pravou stranu")
 LL_TIM_OC_SetCompareCH3(TIM3,1); // vzestupn hrana PWM 1 tik po startu timeru
 LL_TIM_CC_EnableChannel(TIM3,LL_TIM_CHANNEL_CH3); // od te m TIM3 kontrolu nad CH3 (PB0)

 // nastaven master chovn
 LL_TIM_SetTriggerOutput(TIM3,LL_TIM_TRGO_ENABLE); // vypustit TRGO signl jakmile je timer sputn

 // Nastaven Slave chovn
 LL_TIM_SetTriggerInput(TIM3,LL_TIM_TS_TI1FP1); // Reagovat na signl TI1FP1
 LL_TIM_SetSlaveMode(TIM3,LL_TIM_SLAVEMODE_TRIGGER); // udlost timer spustit
}

// dokonen sbr vzork jednoho pulzu
void DMA1_Channel1_IRQHandler(void){
	INFO_H; // informujeme e probh reset DMA a ADC k dalmu men
	LL_DMA_ClearFlag_TC1(DMA1); // vyistit vlajku abychom mohli detekovat pt udlost (konec sbru)
	if(pulse < PULSE_COUNT){ // dokud nenasbrme PULSE_COUNT zznam
		LL_DMA_DisableChannel(DMA1,LL_DMA_CHANNEL_1); // vypneme DMA abychom ho mohli rekonfigurovat
		LL_DMA_SetMemoryAddress(DMA1,LL_DMA_CHANNEL_1,(uint32_t)&pulses[pulse][0]); // nastavme novou adresu kam ukldat dal pulz
		LL_DMA_SetDataLength(DMA1,LL_DMA_CHANNEL_1,SAMPLES); // znovunastavme poet vzork jednho men
		LL_DMA_EnableChannel(DMA1,LL_DMA_CHANNEL_1); // povolme DMA kanl
		LL_ADC_REG_StartConversion(ADC1); // povlme ADC ekat na trigger a zahjt sbr dat
		pulse++; // zapotme dal pulz
	}else{  // posbrali jsme PULSE_COUNT zznam a mme hotovo
		hotovo=1; // dme vdt hlavn smyce e pole je pln dat
	}
	INFO_L;
}


static void MX_ADC_Init(void){
  LL_ADC_InitTypeDef ADC_InitStruct = {0};
  LL_ADC_REG_InitTypeDef ADC_REG_InitStruct = {0};
  LL_GPIO_InitTypeDef GPIO_InitStruct = {0};
  LL_DMA_InitTypeDef dma;

  uint16_t del=10; // poslou k realizaci tupho delay

  LL_APB1_GRP2_EnableClock(LL_APB1_GRP2_PERIPH_ADC1);
  LL_AHB1_GRP1_EnableClock(LL_AHB1_GRP1_PERIPH_GPIOA);
  LL_AHB1_GRP1_EnableClock(LL_AHB1_GRP1_PERIPH_DMA1);
  
  // PA0 je vstup pro ADC
  GPIO_InitStruct.Pin = LL_GPIO_PIN_0;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_ANALOG;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  LL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  // 1.konfigurace ADC
  ADC_InitStruct.Clock = LL_ADC_CLOCK_ASYNC; // taktujeme internm 14MHz osciltorem (umouje nejrychlej pevod)
  ADC_InitStruct.Resolution = LL_ADC_RESOLUTION_12B; // rozlien lze volit rzn, men rozlien zkracuje dobu pevodu
  ADC_InitStruct.DataAlignment = LL_ADC_DATA_ALIGN_RIGHT; // data zarovnan vpravo
  ADC_InitStruct.LowPowerMode = LL_ADC_LP_MODE_NONE; // low power mdy ns te nezajmaj
  LL_ADC_Init(ADC1, &ADC_InitStruct); // provede nastaven ADC

  // 2.konfigurace ADC
  ADC_REG_InitStruct.TriggerSource = LL_ADC_REG_TRIG_EXT_TIM3_TRGO; // pevod startovat TRGO sginlem z TIM3
  ADC_REG_InitStruct.SequencerDiscont = LL_ADC_REG_SEQ_DISCONT_DISABLE; // seqvencer nepouvme, Discontinuous reim nechceme
  ADC_REG_InitStruct.ContinuousMode = LL_ADC_REG_CONV_CONTINUOUS; // volme kontinuln reim (!), ADC pevd od trigru, do signlu od DMA (konce penosu)
  ADC_REG_InitStruct.DMATransfer = LL_ADC_REG_DMA_TRANSFER_LIMITED; // DMA m oprvnn zastavit pevod, jakmile dojde ke konci penosu (DMA d poet pevod)
  ADC_REG_InitStruct.Overrun = LL_ADC_REG_OVR_DATA_PRESERVED; // overrun neoetujeme, take to je jedno
  LL_ADC_REG_Init(ADC1, &ADC_REG_InitStruct); // provede nastaven ADC

  // kalibrace ADC
  LL_ADC_StartCalibration(ADC1); // zahj kalibraci
  while(LL_ADC_IsCalibrationOnGoing(ADC1)); // pok na dokonen
  while(del){del--;} //pok alespo 2us od kalibrace

  // sputn DAC
  LL_ADC_Enable(ADC1); // spustme ADC
  while(!LL_ADC_IsActiveFlag_ADRDY(ADC1)); // pokme a se ADC rozbhne
  LL_ADC_ClearFlag_ADRDY(ADC1); // uklidme po sob vlajku

  // konfigurace DMA
  dma.Direction = LL_DMA_DIRECTION_PERIPH_TO_MEMORY; // transfer z ADC (periferie) do pamti
  dma.MemoryOrM2MDstAddress = (uint32_t)pulses; // nezle, budeme ji nastavovat znovu
  dma.MemoryOrM2MDstIncMode = LL_DMA_MEMORY_INCREMENT; // na stran pamti inkrementovat adresu
  dma.MemoryOrM2MDstDataSize = LL_DMA_MDATAALIGN_HALFWORD; // penme 16bit (tady zmnit pokud penastavme ADC na 8 nebo 6bit)
  dma.Mode = LL_DMA_MODE_NORMAL; // jednorzov penos
  dma.NbData = SAMPLES; // poet penench vzork (bezle, budeme jej nastavovat znvou)
  dma.PeriphOrM2MSrcAddress = (uint32_t)(&(ADC1->DR)); // zdrojov adresa v periferii (ADC)
  dma.PeriphOrM2MSrcDataSize = LL_DMA_PDATAALIGN_HALFWORD; // z periferie (ADC) penme 16bit (tady zmnit pokud penastavme ADC na 8 nebo 6bit)
  dma.PeriphOrM2MSrcIncMode = LL_DMA_PERIPH_NOINCREMENT; // v periferii (ADC) nechat adresu konstantn (neinkrementovat)
  dma.Priority = LL_DMA_PRIORITY_HIGH; // priorita DMA je celkem vysok (nem vliv, protoe jin DMA kanly stejn neb)
  LL_DMA_Init(DMA1,LL_DMA_CHANNEL_1,&dma); // nastavit DMA (channel 1 odpovd requestm od ADC)

  // nastavit peruen od DMA
  __NVIC_SetPriority(DMA1_Channel1_IRQn,0); // vysok priorita
  __NVIC_EnableIRQ(DMA1_Channel1_IRQn); // povolit v NVIC
  LL_DMA_EnableIT_TC(DMA1,LL_DMA_CHANNEL_1); // povolit peruen od Transfer Complete naeho channel 1
}


static void MX_GPIO_Init(void){
	LL_GPIO_InitTypeDef GPIO_InitStruct = {0};
  LL_AHB1_GRP1_EnableClock(LL_AHB1_GRP1_PERIPH_GPIOF);
  LL_AHB1_GRP1_EnableClock(LL_AHB1_GRP1_PERIPH_GPIOB);

  // nastavme informan vstup PB1
  GPIO_InitStruct.Pin = LL_GPIO_PIN_1;
  GPIO_InitStruct.Mode = LL_GPIO_MODE_OUTPUT;
  GPIO_InitStruct.Speed = LL_GPIO_SPEED_FREQ_LOW;
  GPIO_InitStruct.OutputType = LL_GPIO_OUTPUT_PUSHPULL;
  GPIO_InitStruct.Pull = LL_GPIO_PULL_NO;
  GPIO_InitStruct.Alternate = LL_GPIO_AF_1;
  LL_GPIO_Init(GPIOB, &GPIO_InitStruct);
}


// taktujeme ip z intrnho 48MHz oscilltoru (plat pro F042, vtina jinch F0 bude nejsp taktovna z PLL)
void SystemClock_Config(void)
{
  LL_FLASH_SetLatency(LL_FLASH_LATENCY_1);

  if(LL_FLASH_GetLatency() != LL_FLASH_LATENCY_1)
  {
  Error_Handler();
  }
  LL_RCC_HSI48_Enable();

  while(LL_RCC_HSI48_IsReady() != 1)
  {

  }
  LL_RCC_SetAHBPrescaler(LL_RCC_SYSCLK_DIV_1);
  LL_RCC_SetAPB1Prescaler(LL_RCC_APB1_DIV_1);
  LL_RCC_SetSysClkSource(LL_RCC_SYS_CLKSOURCE_HSI48);

  while(LL_RCC_GetSysClkSource() != LL_RCC_SYS_CLKSOURCE_STATUS_HSI48)
  {

  }
  LL_Init1msTick(48000000);
  LL_SetSystemCoreClock(48000000);
}

void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
